/**
 * This example turns the ESP32 into a Bluetooth LE keyboard that writes the words, presses Enter, presses a media key and then Ctrl+Alt+Delete
 */
#include <BleKeyboard.h>
#include <iostream>
#include <vector>
#include <Bounce2.h>

BleKeyboard bleKeyboard;
class GameButton{
  
  public:
    int buttonPin;  // the number of the pushbutton pin
    // variable for storing the pushbutton status 
    int buttonKey;
    Bounce2::Button button;

    GameButton(int pin, uint8_t key){
      buttonPin = pin;
      buttonKey = key;
      setupButton();
    };

    void setupButton(){

      button = Bounce2::Button();
      button.attach( buttonPin, INPUT_PULLDOWN );
      button.interval( 25 );
      button.setPressedState(HIGH); 
    };

    void catchButtonPress(){
          button.update();

          if (button.pressed()) {
              bleKeyboard.press(buttonKey);      
          }
          if(button.released()){
              bleKeyboard.release(buttonKey);      
          }
    };

};

std::vector <GameButton> buttons = {
  GameButton(4,KEY_UP_ARROW),
  GameButton(5,KEY_DOWN_ARROW),
  GameButton(13,KEY_LEFT_ARROW),
  GameButton(12,KEY_RIGHT_ARROW),
  GameButton(14,KEY_UP_ARROW),
  GameButton(27,KEY_RIGHT_SHIFT),
};

void setup() {
  Serial.begin(115200);
  Serial.println("Starting BLE work!");
  bleKeyboard.begin();
}

void loop() {
  if(bleKeyboard.isConnected()) {
      for (int i =0; i<buttons.size();i++){
       buttons[i].catchButtonPress();
     }  
  }
}
  

